package com.jts.saga.config;

import java.util.function.Function;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import com.jts.saga.common.OrchestratorRequestDTO;
import com.jts.saga.common.OrchestratorResponseDTO;
import com.jts.saga.service.OrchestratorService;

import reactor.core.publisher.Flux;

@Configuration
public class OrchestratorConfig {

	@Autowired
	private OrchestratorService orchestratorService;

	@Bean
	public Function<Flux<OrchestratorRequestDTO>, Flux<OrchestratorResponseDTO>> processor() {
		return flux -> flux.flatMap(dto -> orchestratorService.orderProduct(dto))
				.doOnNext(dto -> System.out.println("Status : " + dto.getStatus()));
	}

}
